import es, path, zipfile, string

info = es.AddonInfo()
info.version = '1.0'
info.author = 'Ojii'

gp = path.path(str(es.ServerVar('eventscripts_gamedir')))

def load():
    es.regcmd('build','builder/build')
    
def build():
    print ''
    if es.getargc() != 2:
        print 'BUILDER: Invalid syntax! Use: build <addon>'
        return
    ap = path.path(es.getAddonPath(es.getargv(1)))
    if not ap.isdir():
        print 'BUILDER: Couldn\'t find addon: %s' % es.getargv(1)
        return
    name = es.getargv(1)
    print 'BUILDER: Scanning main file for version info'
    version = None
    main = ap.joinpath('%s.py' % name) if ap.joinpath('%s.py' % name).isfile() else ap.joinpath('es_%s.txt' % name)
    if not main.isfile():
        print 'BUILDER: Couldn\'t find main script file!'
        return
    for line in main.lines(retain=False):
        if line.strip().startswith('info.version'):
            version = line.split('=')[1].strip().strip("'")
            print 'BUILDER: Version found: %s' % version
            break
    print 'BUILDER: Writing zipfile'
    zf = ap.joinpath('%s_%s.zip' % (name,version.replace(':','_')))
    zip = zipfile.ZipFile(zf,'w')
    for f in ap.walkfiles('*.py'):
        print 'BUILDER: Adding %s' % f.encode('ascii')
        zip.write(f.encode('ascii'),gp.relpathto(f).encode('ascii'))
    for f in ap.walkfiles('*.txt'):
        print 'BUILDER: Adding %s' % f.encode('ascii')
        zip.write(f.encode('ascii'),gp.relpathto(f).encode('ascii'))
    for f in ap.walkfiles('*.cfg'):
        print 'BUILDER: Adding %s' % f.encode('ascii')
        zip.write(f.encode('ascii'),gp.relpathto(f).encode('ascii'))
    for f in ap.walkfiles('*.ini'):
        print 'BUILDER: Adding %s' % f.encode('ascii')
        zip.write(f.encode('ascii'),gp.relpathto(f).encode('ascii'))
    zip.close()
    print 'BUILDER: Done'
    print ''